--- flua.lua - top level stuff: compile a demo to an engine file in C
--- and a bytecode file in Nasm.
--
-- Copyright (C) 2001 Eduardo Ochs.
-- Author:     Eduardo Ochs <edrx@mat.puc-rio.br>
-- Version:    0.02 (2001apr29).
--
-- This program was copylefted to prevent against patent psychopaths;
-- if you want a version with any other license you'll have to write
-- it yourself. More formally,
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License as
-- published by the Free Software Foundation; either version 2 of the
-- License, or (at your option) any later version.

-- Flua is an experimental Forth-like language, built on top of Lua, C
-- and Nasm. It is an implementation of the ideas of my (old) "Crim"
-- project.
--
-- Related files:
-- (find-flua "flua-comp.lua")
-- (find-flua "flua-demos.lua")
-- (find-flua "flua-lua.lua")
-- (find-flua "inc.lua")

-- .command_line	(to "command_line")




DBG = getenv("DBG")

dofile("inc.lua")
dofile("flua-comp.lua")
dofile("flua-lua.lua")
dofile("flua-demos.lua")
dofile("flua-demos-old.lua")



--%%%%%
--%
--% Run the demo selected by arg[2] (if arg[1] is "do_demo(arg[2])")
--%
--%%%%%

function do_demo(demoname)
  demodir = ""
  enginefile   = format("%s%s.engine.c",     demodir, demoname)
  bytecodefile = format("%s%s.bytecode.asm", demodir, demoname)

  getglobal("flua_" .. demoname)()
  build_engine_strings()
  -- dump_engine_strings()

  process_C_skeleton("skel.engine.c", enginefile)
  printf("Wrote engine file:   %s\n", enginefile)

  process_nasm_skeleton("skel.bytecode.asm", bytecodefile)
  printf("Wrote bytecode file: %s\n", bytecodefile)
end



-- command_line  (to ".command_line")
-- (find-flua "Makefile")
-- (find-flua "flua-demos.lua" "flua_demo1")
-- (find-flua "flua-demos.lua" "flua_demo2")
-- (find-flua "flua-demos.lua" "flua_demo3")
-- (find-flua "flua-demos.lua" "flua_demo4")
-- (find-flua "flua-demos.lua" "flua_demo5")
--
dostring(arg[1])





--
-- Local Variables:
-- coding:               no-conversion
-- ee-anchor-format:     "%s"
-- ee-charset-indicator: ""
-- End:
